/*********************
**      Chat        **   The Chat System by SLB
**  Miscellaneous   ** 
**   Subroutines    **        Revision 6.0
**		    **
** prtime()	    **            September 18, 1985
** who()	    **
** ridname()	    **
** cmds()	    **  (misc.c - Written by Sanford L. Barr)
** putch()	    **
** shell()	    **
** error()	    **
** sysexec()	    **
**********************/

/*
 * Modified by Lennart Andersson, MOTALA, SWEDEN
 * 19 october 1987
 */
 

#include "chat.h"

prtime(ti, strng)	/* prtime returns the time in 24 hour format to	strng */
char	*strng;
long	ti;
{
	struct	tm	*tp;
	struct	tm	*localtime();
	int	tim,
		min,
		pm;

	tp = localtime(&ti);
	tim = tp->tm_hour;		/* Set hours */
	min = tp->tm_min;		/* Set mins  */
	sprintf(strng, "%2d:%02d", tim, min);
	return;
}

cmds()	/* Print command list */
{
	char	input;

	clear();			/* Clear Screen */
	puts("\r\n\r\n\r\n\
------------------------------------\r\n\
------Chat System Command List------\r\n\
------------------------------------\r\n\
These are the available	commands:  -\r\n\
                                   -\r\n\
(L)	Display	users logged in.   -\r\n\
(P)	Page a user via mail(1).   -\r\n\
(Q)	Exit chat session.         -\r\n\
(S)	Send message.              -\r\n\
(V)	Display	version	number.    -\r\n\
(W)	See who's logged into Chat.-\r\n\
(!)	Execute	shell command.     -\r\n\
(!sh)	Escape to shell.	   -\r\n\
(?)	Print this menu.           -\r\n\
------------------------------------\r\n\
");
	hilight("Press [Return] to Continue:");
	while ((input = getchar()) != 13);
	clear();
	return;
}

putch(ch)			/* output a character */
int ch;
{
	putchar(ch);
}

shell()		/* Read	and execute a shell command */
{
	char	input[80],
		chr;

	ttyset(OFF,ON);				/* back	to normal */
	fputs("\r\nSuspending Chat: Enter command and hit return\r\n!",stdout);
	fgets(input, 80, stdin);

	if (sysexec(input) == 127)
		puts("EXECUTION ERROR: Can't generate a shell\r");

	ttyset(ON,OFF);				/* Cbreak again */
	hilight("Press [Return] to Resume Chat:");
	while ((chr = getchar()) != 13);
	clear();				/* Clear Screen */
}

who(f, cl)		/* Show	who's logged into chat */
int f, cl;
{
  	int 	temp;
 	char	tmpstr[40];

	users =	0;

	lseek(lfile, 0L, 0);		/* Rewind LOGFILE */
	if (!f)	{
		if (cl)
			clear(); 	/* Clear Screen */
		puts("\r\n\r");
		puts("Users In Chat         Tty         When\r");
	}

	while ((temp=read(lfile, (char *) &lbuf, sizeof(lbuf)))==sizeof(lbuf)){
		if (lbuf.l_line[0]=='\0' || lbuf.l_name[0]=='\0')
			continue;	/* Skip	blankies */
		if (users > MAXUSERS)
			break;

		sprintf(tmpstr,"%%%d.%ds",LINELEN,LINELEN);
		sprintf(names[users].l_line, tmpstr, lbuf.l_line);
		sprintf(tmpstr,"%%-%d.%ds",NAMELEN,NAMELEN);
		sprintf(names[users].l_name, tmpstr, lbuf.l_name);
		sprintf(tmpstr,"%%%d.%ds",TIMELEN,TIMELEN);
		sprintf(names[users].l_time, tmpstr, lbuf.l_time);

		if (!f)
		{
			sprintf(tmpstr,"%%-%d.%ds %%-%d.%ds	 %%%d.%ds\r\n",
			        NAMELEN,NAMELEN,LINELEN,LINELEN,
			        TIMELEN,TIMELEN);
			printf(tmpstr,lbuf.l_name,lbuf.l_line,lbuf.l_time);
		}

	users++;
	}

	if (!f)
		puts("\r");
	return;
}

error(estring,file)
char	*estring;
{

	fputs("SYSTEM FILE ERROR",stderr);
	if (file)
		fprintf(stderr,"\r\n%s\r\n",estring);
	else
		fprintf(stderr," %s\r\n");
}

ridname()	/* Get's rid of	user, on mytty,	in LOGFILE */
{
	lseek(lfile, 0L, 0);			/* Rewind file */

	buffer[0] = '\0';
	while(read(lfile, (char	*) &lbuf, sizeof(lbuf))	== sizeof(lbuf)) {
		if (!strncmp(lbuf.l_line, mytty, length))
			continue;

		strncat(buffer,	lbuf.l_line, sizeof(lbuf.l_line));
		strncat(buffer,	lbuf.l_name, sizeof(lbuf.l_name));
		strncat(buffer,	lbuf.l_time, sizeof(lbuf.l_time));

	}
	strcat(buffer, "\0");

	if ((wfd=fopen(LOGFILE,	"w")) == FERROR) {
		perror(LOGFILE);
		return(ERR);
	}
	fputs(buffer, wfd);

	if (fclose(wfd)	== ERR)	{
		perror(LOGFILE);
		return(ERR);
	}
	return(OK);
}

sysexec(s)
char *s;
{
	int status, pid, w;
	register int (*istat)(), (*qstat)();

	if ((pid = fork()) == 0) {
		setgid(getgid());
		setuid(getuid());
		execl("/bin/sh", "sh", "-c", s,	0);
		_exit(127);
	}
	istat =	signal(SIGINT, SIG_IGN);
	qstat =	signal(SIGQUIT,	SIG_IGN);
	while ((w = wait(&status)) != pid && w != -1)
		;
	if (w == -1)
		status = -1;
	signal(SIGINT, istat);
	signal(SIGQUIT,	qstat);
	return(status);
}

